'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _HistoryEntry = require('./HistoryEntry');

var _HistoryEntry2 = _interopRequireDefault(_HistoryEntry);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var History = function (_Component) {
  _inherits(History, _Component);

  function History() {
    _classCallCheck(this, History);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(History).apply(this, arguments));
  }

  _createClass(History, [{
    key: 'generateHistoryEntries',
    value: function generateHistoryEntries(stack) {
      return stack.map(function (entry) {
        return _react2.default.createElement(
          _HistoryEntry2.default,
          null,
          entry.getPlainText()
        );
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var undoStack = this.props.editorState.getUndoStack();
      var redoStack = this.props.editorState.getRedoStack().reverse();
      var undoHistory = this.generateHistoryEntries(undoStack);
      var redoHistory = this.generateHistoryEntries(redoStack);

      return _react2.default.createElement(
        'div',
        null,
        redoHistory,
        _react2.default.createElement(
          _HistoryEntry2.default,
          null,
          this.props.editorState.getCurrentContent().getPlainText()
        ),
        undoHistory
      );
    }
  }]);

  return History;
}(_react.Component);

History.propTypes = {
  editorState: _react.PropTypes.any.isRequired
};

exports.default = History;